// src/router.ts
import f from "regexparam";
import {
  lookup as u,
  save as m
} from "worktop/cache";
import {ServerRequest as y} from "worktop/request";
import {ServerResponse as h} from "worktop/response";

// src/internal/constants.ts
var d = {
  "400": "Bad Request",
  "401": "Unauthorized",
  "403": "Forbidden",
  "404": "Not Found",
  "405": "Method Not Allowed",
  "406": "Not Acceptable",
  "409": "Conflict",
  "410": "Gone",
  "411": "Length Required",
  "413": "Payload Too Large",
  "422": "Unprocessable Entity",
  "428": "Precondition Required",
  "429": "Too Many Requests",
  "500": "Internal Server Error",
  "501": "Not Implemented",
  "502": "Bad Gateway",
  "503": "Service Unavailable",
  "504": "Gateway Timeout"
};

// src/router.ts
async function l(s, p, n, ...r) {
  let e = await s(p, n, ...r);
  return e instanceof Response ? e : new Response(n.body, n);
}
function R() {
  let s, p = {};
  return s = {
    add(n, r, e) {
      let t = p[n];
      if (t === void 0 && (t = p[n] = {
        __d: new Map(),
        __s: {}
      }), r instanceof RegExp)
        t.__d.set(r, {keys: [], handler: e});
      else if (/[:|*]/.test(r)) {
        let {keys: o, pattern: a} = f(r);
        t.__d.set(a, {keys: o, handler: e});
      } else
        t.__s[r] = {keys: [], handler: e};
    },
    find(n, r) {
      let e = {}, t, o, a, c, i;
      if (o = p[n]) {
        if (t = o.__s[r])
          return {params: e, handler: t.handler};
        for ([a, c] of o.__d)
          if (i = a.exec(r), i !== null) {
            if (i.groups !== void 0)
              for (t in i.groups)
                e[t] = i.groups[t];
            else if (c.keys.length > 0)
              for (t = 0; t < c.keys.length; )
                e[c.keys[t++]] = i[t];
            return {params: e, handler: c.handler};
          }
      }
      return {params: e, handler: !1};
    },
    onerror(n, r, e, t) {
      let o = d[e = e || 500], a = t && t.message || o || String(e);
      return new Response(a, {status: e, statusText: o});
    },
    async run(n) {
      let r = new y(n), e = new h(r.method);
      if (s.prepare && await s.prepare(r, e), e.finished)
        return new Response(e.body, e);
      let {params: t, handler: o} = s.find(r.method, r.path);
      if (!o)
        return l(s.onerror, r, e, 404);
      try {
        return r.params = t, l(o, r, e);
      } catch (a) {
        return l(s.onerror, r, e, 500, a);
      }
    },
    listen(n) {
      n.respondWith(u(n).then((r) => r || s.run(n).then((e) => m(n, e))));
    }
  };
}
export {
  R as Router,
  d as STATUS_CODES
};
